-----------------------------------------------------------------
--
--   Beispielskript zum Vortrag "Access und SQL Server-Security"
--	 AEK 21 im Oktober 2018
--
--   Autor: Bernd Jungbluth										
--   Keine Gewhrleistung, keine Haftung
--
-----------------------------------------------------------------

USE AEK21;
GO

----------------------------------------------------------------
-- Per Symmetrischem Schlssel verschlsseln
----------------------------------------------------------------

-- Variable fr interne Guid des symmetrischen Schlssels
DECLARE @symKey	UNIQUEIDENTIFIER;
SET @symKey = KEY_GUID('skeyMitarbeiter');

-- Symmetrischen Schlssel ffnen
OPEN SYMMETRIC KEY sKeyMitarbeiter 
	 DECRYPTION BY PASSWORD = N'DasistderSymmetrischeSchlsselfrdieReligion-denndieistnachArtikel9einebesondereKategorievonDaten!';

-- Wert der Spalte Religion verschlsselt in Spalte crptRelegion speichern
UPDATE	dbo.Mitarbeiter
SET		crptReligion = ENCRYPTBYKEY(@symKey, Religion);

-- Symmetrischen Schlssel schlieen
CLOSE SYMMETRIC KEY sKeyMitarbeiter 
GO

-- Daten lesen
SELECT MitarbeiterID, Nachname, Religion, crptReligion FROM dbo.Mitarbeiter;
GO


----------------------------------------------------------------
-- Per Symmetrischem Schlssel entschlsseln
----------------------------------------------------------------

-- Symmetrischen Schlssel ffnen
OPEN SYMMETRIC KEY sKeyMitarbeiter 
	 DECRYPTION BY PASSWORD = N'DasistderSymmetrischeSchlsselfrdieReligion-denndieistnachArtikel9einebesondereKategorievonDaten!';

-- Daten lesen
SELECT	
		MitarbeiterID, PersonalNr, Nachname, Vorname, 
		Religion, 
		CAST(DECRYPTBYKEY(crptReligion) AS NVARCHAR(50)) As crptReligion,
		crptReligion As crptReligionBinr,
		Position, Anrede, Geburtsdatum, 
		Einstellung, Durchwahl, Mobil, Email, Bemerkungen, Vorgesetzter, AktuellesGehalt
FROM	
		dbo.Mitarbeiter;

-- Symmetrischen Schlssel schlieen
CLOSE SYMMETRIC KEY sKeyMitarbeiter;
GO
